VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPwrScheme"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

'Autor: Achim Neubauer

Option Explicit

Private Col_Index As New Collection
Private Col_Name As New Collection
Private Col_Description As New Collection
Private Col_IDs As New Collection

Public Enum CPwrScheme_ErrorConstants
  ERR_GETACTIVEPWRSCHEME = vbObjectError + 513
  ERR_SETACTIVEPWRSCHEME = vbObjectError + 514
  ERR_DELETEPWRSCHEME = vbObjectError + 515
  ERR_READPWRSCHEME = vbObjectError + 516
  ERR_WRITEPWRSCHEME = vbObjectError + 517
  ERR_ENUMPWRSCHEMES = vbObjectError + 518
End Enum

'***

Friend Property Get ActiveID() As Long
  Dim ID As Long
  
  If GetActivePwrScheme(ID) = 0 Then
    Err.Raise ERR_GETACTIVEPWRSCHEME, "CPwrScheme:ActiveID", "API GetActivePwrScheme failed."
    Exit Property
    
  End If
  
  ActiveID = ID
End Property

Friend Property Let ActiveID(ByVal NewValue As Long)
  If SetActivePwrScheme(NewValue, 0&, 0&) = 0 Then
    Err.Raise ERR_SETACTIVEPWRSCHEME, "CPwrScheme:ActiveID", "API SetActivePwrScheme failed."
    Exit Property
    
  End If
End Property

'***

Friend Property Get Scheme(ByVal ID As Long) As POWER_POLICY
  Dim PP As POWER_POLICY
  
  If ReadPwrScheme(ID, PP) = 0 Then
    Err.Raise ERR_READPWRSCHEME, "CPwrScheme:Scheme", "API ReadPwrScheme failed."
    Exit Property
    
  End If
  
  Scheme = PP
End Property

Friend Property Let Scheme(ByVal ID As Long, NewValue As POWER_POLICY)
  Call EnumData
  
  If WritePwrScheme(ID, Col_Name("ID" & CStr(ID)), Col_Description("ID" & CStr(ID)), NewValue) = 0 Then
    Err.Raise ERR_WRITEPWRSCHEME, "CPwrScheme:Scheme", "API WritePwrScheme failed."
    Exit Property
    
  End If

  If SetActivePwrScheme(ID, 0&, 0&) = 0 Then
    Err.Raise ERR_SETACTIVEPWRSCHEME, "CPwrScheme:Scheme", "API SetActivePwrScheme failed."
    Exit Property
    
  End If
End Property

'***

Friend Property Get Name(ByVal ID As Long) As String
  If Not EnumData Then
    Err.Raise ERR_ENUMPWRSCHEMES, "CPwrScheme:Name", "API EnumPwrSchemes failed."
    Exit Property
    
  End If
  
  Name = Col_Name("ID" & CStr(ID))
End Property

Friend Property Let Name(ByVal ID As Long, NewValue As String)
  Dim PP As POWER_POLICY
  
  If Not EnumData Then
    Err.Raise ERR_ENUMPWRSCHEMES, "CPwrScheme:Name", "API EnumPwrSchemes failed."
    Exit Property
    
  End If
  
  If ReadPwrScheme(ID, PP) = 0 Then
    Err.Raise ERR_READPWRSCHEME, "CPwrScheme:Name", "API ReadPwrScheme failed."
    Exit Property
    
  End If
  
  If WritePwrScheme(ID, NewValue, Col_Description("ID" & CStr(ID)), PP) = 0 Then
    Err.Raise ERR_WRITEPWRSCHEME, "CPwrScheme:Name", "API WritePwrScheme failed."
    Exit Property
    
  End If
  
  If SetActivePwrScheme(ID, 0&, 0&) = 0 Then
    Err.Raise ERR_SETACTIVEPWRSCHEME, "CPwrScheme:Name", "API SetActivePwrScheme failed."
    Exit Property
    
  End If
End Property

'***

Friend Property Get Description(ByVal ID As Long) As String
  If Not EnumData Then
    Err.Raise ERR_ENUMPWRSCHEMES, "CPwrScheme:Description", "API EnumPwrSchemes failed."
    Exit Property
    
  End If
  
  Description = Col_Description("ID" & CStr(ID))
End Property

Friend Property Let Description(ByVal ID As Long, NewValue As String)
  Dim PP As POWER_POLICY
  
  If Not EnumData Then
    Err.Raise ERR_ENUMPWRSCHEMES, "CPwrScheme:Description", "API EnumPwrSchemes failed."
    Exit Property
    
  End If
  
  If ReadPwrScheme(ID, PP) = 0 Then
    Err.Raise ERR_READPWRSCHEME, "CPwrScheme:Description", "API ReadPwrScheme failed."
    Exit Property
    
  End If
  
  If WritePwrScheme(ID, Col_Name("ID" & CStr(ID)), NewValue, PP) = 0 Then
    Err.Raise ERR_WRITEPWRSCHEME, "CPwrScheme:Description", "API WritePwrScheme failed."
    Exit Property
    
  End If
  
  If SetActivePwrScheme(ID, 0&, 0&) = 0 Then
    Err.Raise ERR_SETACTIVEPWRSCHEME, "CPwrScheme:Description", "API SetActivePwrScheme failed."
    Exit Property
    
  End If
End Property

'***

Public Sub DeleteScheme(ByVal ID As Long)
  If DeletePwrScheme(ID) = 0 Then
    Err.Raise ERR_DELETEPWRSCHEME, "CPwrScheme:DeleteScheme", "API DeletePwrScheme failed."
    Exit Sub
    
  End If
End Sub

'***

Friend Property Get IDs() As Collection
  If Not EnumData Then
    Err.Raise ERR_ENUMPWRSCHEMES, "CPwrScheme:IDs", "API EnumPwrSchemes failed."
    Exit Property
    
  End If
  
  Set IDs = Col_IDs
End Property
  
'***

Friend Property Get MonitorStandybyHalted() As Boolean
  Dim State As Long
  
  State = SetThreadExecutionState(0&)
  
  MonitorStandybyHalted = ((State And ES_DISPLAY_REQUIRED) = ES_DISPLAY_REQUIRED)
End Property

Friend Property Let MonitorStandybyHalted(NewValue As Boolean)
  Dim State As Long
  
  State = SetThreadExecutionState(0&)
  
  If NewValue Then
    State = State Or ES_DISPLAY_REQUIRED
  Else
    State = State And Not ES_DISPLAY_REQUIRED
  End If
  
  Call SetThreadExecutionState(State)
End Property

'***

Friend Property Get SystemStandybyHalted() As Boolean
  Dim State As Long
  
  State = SetThreadExecutionState(0&)
  
  MonitorStandybyHalted = ((State And ES_SYSTEM_REQUIRED) = ES_SYSTEM_REQUIRED)
End Property

Friend Property Let SystemStandybyHalted(NewValue As Boolean)
  Dim State As Long
  
  State = SetThreadExecutionState(0&)
  
  If NewValue Then
    State = State Or ES_SYSTEM_REQUIRED
  Else
    State = State And Not ES_SYSTEM_REQUIRED
  End If
  
  Call SetThreadExecutionState(State)
End Property

'***

Private Function EnumData() As Boolean
  Dim PS() As PWR_SCHEME
  Dim Result As Long
  Dim T As Long
  
  Set Col_Index = New Collection
  Set Col_IDs = New Collection
  Set Col_Name = New Collection
  Set Col_Description = New Collection
  
  Result = GetAllPwrSchemes(PS)
  
  If Result >= 0 Then EnumData = True
  
  For T = 1 To Result
    Col_Index.Add T, "ID" & CStr(PS(T).ID)
    Col_IDs.Add PS(T).ID, "Index" & CStr(T)
    Col_Name.Add PS(T).Name, "ID" & CStr(PS(T).ID)
    Col_Description.Add PS(T).Desc, "ID" & CStr(PS(T).ID)
  Next T
End Function
