Attribute VB_Name = "modPwrSchemes"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

'Autor: Achim Neubauer

'*** power management documentation:
'*** http://msdn.microsoft.com/library/en-us/power/base/power_management_functions.asp

Option Explicit

'*** stuff

Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

'*** power management apis (private ones will be implemented later)

Private Declare Function EnumPwrSchemes Lib "powrprof.dll" (ByVal lpfnPwrSchemesEnumProc As Long, Optional ByRef lParam As Long) As Byte

Public Declare Function GetActivePwrScheme Lib "powrprof.dll" (ByRef puiID As Long) As Long
Public Declare Function SetActivePwrScheme Lib "powrprof.dll" (ByVal puiID As Long, ByVal lpGlobalPowerPolicy As Long, ByVal lpPowerPolicy As Long) As Long

Public Declare Function ReadPwrScheme Lib "powrprof.dll" (ByVal puiID As Long, ByRef pPowerPolicy As POWER_POLICY) As Long
Public Declare Function WritePwrScheme Lib "powrprof.dll" (ByRef puiID As Long, ByVal lpszName As String, ByVal lpszDescription As String, ByRef pPowerPolicy As POWER_POLICY) As Byte
Public Declare Function DeletePwrScheme Lib "powrprof.dll" (ByVal uiIndex As Long) As Byte

Public Declare Function SetThreadExecutionState Lib "kernel32.dll" (ByVal esFlags As ExecutionStateConstants) As Long

'*** other related apis

'dunno how to use it ;)
'Public Declare Function GetDevicePowerState Lib "kernel32.dll" (ByVal hDevice As Long, ByRef pfOn As Long) As Long

'*** power management enums

Public Enum POWER_ACTION
  PowerActionNone
  PowerActionReserved
  PowerActionSleep
  PowerActionHibernate
  PowerActionShutdown
  PowerActionShutdownReset
  PowerActionShutdownOff
  PowerActionWarmEject
End Enum

Public Enum SYSTEM_POWER_STATE
  PowerSystemUnspecified
  PowerSystemWorking
  PowerSystemSleeping1
  PowerSystemSleeping2
  PowerSystemSleeping3
  PowerSystemHibernate
  PowerSystemShutdown
  PowerSystemMaximum
End Enum

Public Enum ExecutionStateConstants
  ES_SYSTEM_REQUIRED = &H1
  ES_DISPLAY_REQUIRED = &H2
  ES_USER_PRESENT = &H4
  ES_CONTINUOUS = &H80000000
End Enum

'*** power management types

Public Type POWER_ACTION_POLICY
  Action As POWER_ACTION
  Flags As Long
  EventCode As Long
End Type

Public Type USER_POWER_POLICY
  Revision As Long
  IdleAc As POWER_ACTION_POLICY
  IdleDc As POWER_ACTION_POLICY
  IdleTimeoutAc As Long
  IdleTimeoutDc As Long
  IdleSensitivityAc As Byte
  IdleSensitivityDc As Byte
  ThrottlePolicyAc As Byte
  ThrottlePolicyDc As Byte
  MaxSleepAc As SYSTEM_POWER_STATE
  MaxSleepDc As SYSTEM_POWER_STATE
  Reserved(1) As Long
  VideoTimeoutAc As Long
  VideoTimeoutDc As Long
  SpindownTimeoutAc As Long
  SpindownTimeoutDc As Long
  OptimizeForPowerAc As Byte
  OptimizeForPowerDc As Byte
  FanThrottleToleranceAc As Byte
  FanThrottleToleranceDc As Byte
  ForcedThrottleAc As Byte
  ForcedThrottleDc As Byte
End Type

Public Type MACHINE_POWER_POLICY
  Revision As Long
  MinSleepAc As SYSTEM_POWER_STATE
  MinSleepDc As SYSTEM_POWER_STATE
  ReducedLatencySleepAc As SYSTEM_POWER_STATE
  ReducedLatencySleepDc As SYSTEM_POWER_STATE
  DozeTimeoutAc As Long
  DozeTimeoutDc As Long
  DozeS4TimeoutAc As Long
  DozeS4TimeoutDc As Long
  MinThrottleAc As Byte
  MinThrottleDc As Byte
  pad1(1) As Byte
  OverThrottledAc As POWER_ACTION_POLICY
  OverThrottledDc As POWER_ACTION_POLICY
End Type

Public Type POWER_POLICY
  user As USER_POWER_POLICY
  mach As MACHINE_POWER_POLICY
End Type

'*** stuff for enumeration

Public Type PWR_SCHEME
  ID As Long
  Name As String
  Desc As String
  PP As POWER_POLICY
End Type

Private EnumSchemesArray() As PWR_SCHEME
Private Number As Long

'*** stuff for execution state

Private LastExecutionState As ExecutionStateConstants

'*** enumeration proc

Private Function PwrSchemesEnumProc(ByVal uiIndex As Long, _
                                   ByVal dwName As Long, _
                                   ByVal lptstrName As Long, _
                                   ByVal dwDesc As Long, _
                                   ByVal lptstrDesc As Long, _
                                   ByRef PP As POWER_POLICY, _
                                   ByRef lParam As Long) As Byte
  
  lParam = lParam + 1 'increase internal counter
  
  Dim Name As String
  Dim Desc As String
    
  Name = Space$(dwName - 1)
  Desc = Space$(dwDesc - 1)
  
  Call CopyMemory(ByVal Name, ByVal lptstrName, dwName - 1)
  Call CopyMemory(ByVal Desc, ByVal lptstrDesc, dwDesc - 1)
  
  ReDim Preserve EnumSchemesArray(0 To lParam)
  
  With EnumSchemesArray(lParam)
    .ID = uiIndex
    .Name = Name
    .Desc = Desc
    .PP = PP
  End With
  
  PwrSchemesEnumProc = 1 'return TRUE to continue
End Function

'*** better api implementations

Public Function GetAllPwrSchemes(Schemes() As PWR_SCHEME) As Long
  If EnumPwrSchemes(AddressOf PwrSchemesEnumProc) = 0 Then
    GetAllPwrSchemes = -1
  Else
    Schemes = EnumSchemesArray
    GetAllPwrSchemes = UBound(EnumSchemesArray)
  End If
End Function
